pcl::CropBox< pcl::PCLPointCloud2 > Class Template Reference
Module filters

CropBox is a filter that allows the user to filter all the data inside of a given box. More...

`#include <pcl/filters/crop_box.h>`

Inheritance diagram for pcl::CropBox< pcl::PCLPointCloud2 >:

## Public Member Functions

| CropBox (bool extract_removed_indices=false)
| Constructor. More...
void | setMin (const Eigen::Vector4f &min_pt)
| Set the minimum point of the box. More...
Eigen::Vector4f | getMin () const
| Get the value of the minimum point of the box, as set by the user. More...
void | setMax (const Eigen::Vector4f &max_pt)
| Set the maximum point of the box. More...
Eigen::Vector4f | getMax () const
| Get the value of the maxiomum point of the box, as set by the user. More...
void | setTranslation (const Eigen::Vector3f &translation)
| Set a translation value for the box. More...
Eigen::Vector3f | getTranslation () const
| Get the value of the box translation parameter as set by the user. More...
void | setRotation (const Eigen::Vector3f &rotation)
| Set a rotation value for the box. More...
Eigen::Vector3f | getRotation () const
| Get the value of the box rotatation parameter, as set by the user. More...
void | setTransform (const Eigen::Affine3f &transform)
| Set a transformation that should be applied to the cloud before filtering. More...
Eigen::Affine3f | getTransform () const
| Get the value of the transformation parameter, as set by the user. More...
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
virtual void | filter (PCLPointCloud2 &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PCLPointCloud2ConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output)
| Sample of point indices into a separate PointCloud. More...
void | applyFilter (std::vector< int > &indices)
| Sample of point indices. More...
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

Eigen::Vector4f | min_pt_
| The minimum point of the box. More...
Eigen::Vector4f | max_pt_
| The maximum point of the box. More...
Eigen::Vector3f | translation_
| The 3D translation for the box. More...
Eigen::Vector3f | rotation_
| The 3D rotation for the box. More...
Eigen::Affine3f | transform_
| The affine transform applied to the cloud. More...
Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
typedef boost::shared_ptr< Filter< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const Filter< pcl::PCLPointCloud2 > > | ConstPtr
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef boost::shared_ptr< PCLPointCloud2 > | PCLPointCloud2Ptr
typedef boost::shared_ptr< PCLPointCloud2 const > | PCLPointCloud2ConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Detailed Description

### template<>
class pcl::CropBox< pcl::PCLPointCloud2 >

CropBox is a filter that allows the user to filter all the data inside of a given box.

Author
  Justin Rosen

Definition at line 211 of file crop_box.h.

## Constructor & Destructor Documentation

## CropBox()

pcl::CropBox< pcl::PCLPointCloud2 >::CropBox | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 224 of file crop_box.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::CropBox< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  output | the resultant point cloud

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::CropBox< pcl::PCLPointCloud2 >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Sample of point indices.

Parameters

  indices | the resultant point cloud indices

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## getMax()

Eigen::Vector4f pcl::CropBox< pcl::PCLPointCloud2 >::getMax | ( |  | ) | const

inline

Get the value of the maxiomum point of the box, as set by the user.

Returns
  the value of the internal max_pt parameter.

Definition at line 266 of file crop_box.h.

## getMin()

Eigen::Vector4f pcl::CropBox< pcl::PCLPointCloud2 >::getMin | ( |  | ) | const

inline

Get the value of the minimum point of the box, as set by the user.

Returns
  the value of the internal min_pt parameter.

Definition at line 248 of file crop_box.h.

## getRotation()

Eigen::Vector3f pcl::CropBox< pcl::PCLPointCloud2 >::getRotation | ( |  | ) | const

inline

Get the value of the box rotatation parameter, as set by the user.

Definition at line 298 of file crop_box.h.

## getTransform()

Eigen::Affine3f pcl::CropBox< pcl::PCLPointCloud2 >::getTransform | ( |  | ) | const

inline

Get the value of the transformation parameter, as set by the user.

Definition at line 314 of file crop_box.h.

References pcl::CropBox< PointT >::applyFilter().

## getTranslation()

Eigen::Vector3f pcl::CropBox< pcl::PCLPointCloud2 >::getTranslation | ( |  | ) | const

inline

Get the value of the box translation parameter as set by the user.

Definition at line 282 of file crop_box.h.

## setMax()

void pcl::CropBox< pcl::PCLPointCloud2 >::setMax | ( | const Eigen::Vector4f & | max_pt | ) |

inline

Set the maximum point of the box.

Parameters

  [in] | max_pt | the maximum point of the box

Definition at line 257 of file crop_box.h.

## setMin()

void pcl::CropBox< pcl::PCLPointCloud2 >::setMin | ( | const Eigen::Vector4f & | min_pt | ) |

inline

Set the minimum point of the box.

Parameters

  [in] | min_pt | the minimum point of the box

Definition at line 239 of file crop_box.h.

## setRotation()

void pcl::CropBox< pcl::PCLPointCloud2 >::setRotation | ( | const Eigen::Vector3f & | rotation | ) |

inline

Set a rotation value for the box.

Parameters

  [in] | rotation | the (rx,ry,rz) values that the box should be rotated by

Definition at line 291 of file crop_box.h.

## setTransform()

void pcl::CropBox< pcl::PCLPointCloud2 >::setTransform | ( | const Eigen::Affine3f & | transform | ) |

inline

Set a transformation that should be applied to the cloud before filtering.

Parameters

  [in] | transform | an affine transformation that needs to be applied to the cloud before filtering

Definition at line 307 of file crop_box.h.

## setTranslation()

void pcl::CropBox< pcl::PCLPointCloud2 >::setTranslation | ( | const Eigen::Vector3f & | translation | ) |

inline

Set a translation value for the box.

Parameters

  [in] | translation | the (tx,ty,tz) values that the box should be translated by

Definition at line 275 of file crop_box.h.

## Member Data Documentation

## max_pt_

Eigen::Vector4f pcl::CropBox< pcl::PCLPointCloud2 >::max_pt_

protected

The maximum point of the box.

Definition at line 335 of file crop_box.h.

## min_pt_

Eigen::Vector4f pcl::CropBox< pcl::PCLPointCloud2 >::min_pt_

protected

The minimum point of the box.

Definition at line 333 of file crop_box.h.

## rotation_

Eigen::Vector3f pcl::CropBox< pcl::PCLPointCloud2 >::rotation_

protected

The 3D rotation for the box.

Definition at line 339 of file crop_box.h.

## transform_

Eigen::Affine3f pcl::CropBox< pcl::PCLPointCloud2 >::transform_

protected

The affine transform applied to the cloud.

Definition at line 341 of file crop_box.h.

## translation_

Eigen::Vector3f pcl::CropBox< pcl::PCLPointCloud2 >::translation_

protected

The 3D translation for the box.

Definition at line 337 of file crop_box.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/crop_box.h